<template>
  <div class="wp-input" :class="{
    'wp-input--active': isInputStateActive}"
    :read-only="$props.readOnly">

    <!-- Text -->
    <input class="wp-input__field" v-if="$props.type === 'text'" v-model="rawVal"
      type="text" :placeholder="$props.placeholder"
      :disabled="($props.disabled || $props.readOnly)"
      @focus="setInputState(InputStates.active)"
      @blur="setInputState(InputStates.default)">

    <!-- Switch -->
    <input v-if="$props.type === 'switch'" type="checkbox" v-model="rawVal"
      class="wp-input__field" :placeholder="$props.placeholder"
      :disabled="$props.disabled" :read-only="$props.readOnly">

    <!-- Dropdown -->
    <wp-dropdown v-if="$props.type === 'dropdown'" v-model="rawVal"
      :placeholder="$props.placeholder" :items="$props.items" :modifiers="$props.modifiers"
      :disabled="$props.disabled" :read-only="$props.readOnly"
      @focus="setInputState(InputStates.active)"
      @unfocus="setInputState(InputStates.default)"
      @select="onSelect"/>

    <!-- Autocomplete -->
    <wp-autocomplete v-if="$props.type === 'autocomplete'" v-model="rawVal"
      :placeholder="$props.placeholder" :items="$props.items" :modifiers="$props.modifiers"
      :disabled="$props.disabled" :read-only="$props.readOnly"
      @focus="setInputState(InputStates.active)"
      @unfocus="setInputState(InputStates.default)"
      @select="onSelect"/>

    <label class="wp-input__label" @click="onLabelClick">
      {{ $props.label }}
    </label>
  </div>
</template>

<script>
import WpAutocomplete from '@/components/input/WpAutocomplete.vue';
import WpDropdown from '@/components/input/WpDropdown.vue';

const InputStates = {
  default: 0,
  active: 1,
  error: 2,
};

export default {
  name: 'WpInput',
  components: {
    WpAutocomplete,
    WpDropdown,
  },
  props: {
    value: {
      required: true,
    },
    type: {
      required: true,
      type: String,
    },
    placeholder: {
      type: String,
      default: '',
    },
    label: {
      type: String,
      default: '',
    },
    items: {
      type: Array,
      default: () => [],
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    readOnly: {
      type: Boolean,
      default: false,
    },
    modifiers: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    return {
      inputState: InputStates.default,
      InputStates,
    };
  },
  computed: {
    rawVal: {
      set(change) {
        this.$emit('input', change);
      },
      get() {
        return this.$props.value;
      },
    },
    isInputStateActive() {
      return this.inputState === InputStates.active;
    },
  },
  methods: {
    setInputState(state) {
      this.inputState = state;
    },
    onSelect(selectedItem) {
      this.$emit('select', selectedItem);
    },
    onLabelClick() {
      if (this.$props.type === 'switch'
        && !this.$props.disabled
        && !this.$props.readOnly) this.rawVal = !this.rawVal;
    },
    changeInputState() {
      if (this.inputState === InputStates.default) {
        this.inputState = InputStates.active;
      } else {
        this.inputState = InputStates.default;
      }
    },
  },
  watch: {
    readOnly: {
      immediate: true,
      handler(newVal) {
        if (newVal) this.setInputState(this.InputStates.default);
      },
    },
  },
};
</script>

<style lang="scss" scoped>
.wp-input {
  position: relative;
  box-sizing: border-box;
  margin-bottom: 15px;
  min-height: 40px;
  width: 100%;
  display: flex;
  flex-direction: column;
  justify-content: flex-start;
  align-items: flex-start;

  &--active {

    .wp-input__label {
      color: $primary;

      &::after {
        background: $primary;
      }

    }

  }

  &[read-only = "true"] {

    .wp-input {

      &__label {

        &::after {
          width: 0;
        }

      }

      &__field {

        &[type = "text"]:hover {
          cursor: default;
        }

      }

    }

  }

  &__label {
    order: -1;
    margin-bottom: 3px;
    color: $neutralDarker;
    font-size: 14px;
    font-family: $firaSans;
    transition: color ease-in-out .2s;

    &::after {
      content: '';
      position: absolute;
      bottom: 0;
      left: 0;
      width: 100%;
      height: 1px;
      background: $neutralDark;
      border-radius: 10px;
      transition: width      ease-in-out .2s,
                  background ease-in-out .2s;
    }

  }

  &__field {
    margin-left: -1px;
    width: 100%;
    height: 15px;
    color: #000;
    font-size: 16px;
    font-family: $roboto;
    border: none;
    outline: none;

    &::placeholder {
      color: $neutralDarker;
    }

    &[type="text"] {

      &:disabled {
        background: #fff;
        cursor: not-allowed;
      }

    }

    // Switch
    &[type="checkbox"] {
      display: none;

      + .wp-input__label {
        display: block;
        margin-bottom: 24px;
        min-width: 70px;
      }

      &:checked {

        + .wp-input__label {

          &:after {
            background: $primaryLight;
            cursor: pointer;
          }

          &:before {
            left: 30px;
            background: $primary;
            cursor: pointer;
          }

        }

      }

      + .wp-input__label {

        &:after {
          z-index: 2;
          content: ' ';
          position: absolute;
          top: 20px;
          left: 0;
          width: 70px;
          height: 15px;
          border-radius: 15px;
          background: $secondaryLight;
          transition: all 0.2s ease-in-out;
          cursor: pointer;
        }

        &:before {
          z-index: 3;
          content: ' ';
          position: absolute;
          top: 20px;
          left: 0;
          width: 40px;
          height: 15px;
          border-radius: 15px;
          background: $secondary;
          transition: all 0.2s ease-in-out;
          cursor: pointer;
        }

      }

      &[read-only = "true"] {

        + .wp-input__label {

          &:after {
            cursor: default;
          }

          &:before {
            cursor: default;
          }

        }

      }

      &:disabled {

        + .wp-input__label {

          &:after {
            background: $neutralLighter;
            cursor: not-allowed;
          }

          &:before {
            background: $neutralDark;
            cursor: not-allowed;
          }

        }

      }

    }

  }

}
</style>
